/**
 *
 */
package de.renew.gui;

import CH.ifa.draw.framework.Figure;

import de.renew.remote.ObjectAccessor;
import de.renew.remote.ObjectAccessorImpl;

import java.rmi.RemoteException;


/**
 * A {@link FigureCreator} that allows to display Figures ({@link Figure}).
 * @author duvigneau, cabac
 *
 */
public class LocalFigureFigureCreator implements FigureCreator {
    /* (non-Javadoc)
     * @see de.renew.gui.FigureCreator#canCreateFigure(de.renew.remote.ObjectAccessor, boolean)
     */
    public boolean canCreateFigure(ObjectAccessor token, boolean expanded)
            throws RemoteException {
        if (token instanceof ObjectAccessorImpl) {
            ObjectAccessorImpl oaimpl = (ObjectAccessorImpl) token;
            Object o = oaimpl.getObject();
            if (o instanceof Figure) {
                Figure fig = (Figure) o;
                return true;
            }
        }
        return false;
    }

    /* (non-Javadoc)
     * @see de.renew.gui.FigureCreator#getTokenFigure(de.renew.remote.ObjectAccessor, boolean)
     */
    public Figure getTokenFigure(ObjectAccessor token, boolean expanded)
            throws RemoteException {
        if (token instanceof ObjectAccessorImpl) {
            ObjectAccessorImpl oaimpl = (ObjectAccessorImpl) token;
            Object o = oaimpl.getObject();
            if (o instanceof Figure) {
                Figure fig = (Figure) o;
                return fig;
            }
        }
        return null;
    }
}