package de.renew.util;

import java.io.Serializable;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;


public class HashedRelation implements Serializable {
    private Map map;

    public HashedRelation() {
        map = new HashMap();
    }

    public synchronized void put(Object key, Object elem) {
        Set set;
        if (map.containsKey(key)) {
            set = (Set) map.get(key);
        } else {
            set = new HashSet();
            map.put(key, set);
        }
        set.add(elem);
    }

    public synchronized void remove(Object key, Object elem) {
        Set set = (Set) map.get(key);
        set.remove(elem);
        if (set.isEmpty()) {
            map.remove(key);
        }
    }

    public synchronized Set keys() {
        return map.keySet();
    }

    public synchronized Set elementsAt(Object key) {
        if (map.containsKey(key)) {
            Set set = (Set) map.get(key);
            return set;
        } else {
            return Collections.EMPTY_SET;
        }
    }

    public synchronized int sizeAt(Object key) {
        if (map.containsKey(key)) {
            Set set = (Set) map.get(key);
            return set.size();
        } else {
            return 0;
        }
    }

    public String toString() {
        StringBuffer buffer = new StringBuffer();
        buffer.append("de.renew.util.HashedRelation( ");
        Iterator keys = map.keySet().iterator();
        while (keys.hasNext()) {
            Object key = keys.next();
            buffer.append(key);
            buffer.append(" -> (");
            Iterator values = ((Set) map.get(key)).iterator();
            boolean first = true;
            while (values.hasNext()) {
                if (first) {
                    first = false;
                } else {
                    buffer.append(", ");
                }
                buffer.append(values.next());
            }
            buffer.append(") ");
        }
        buffer.append(")");
        return buffer.toString();
    }
}